;;;;;;;EZCMP Muliple Pass .asm file
;;;EZCMP Zshell CoMPression library
;;;;;;(c) 1997 by Chris Busch

;;;;;;;;;;This file includes the single pass decompressor.

;;The following variables need to be declared some where.
;;;EZsource start anywhere (like TEXT_MEM for example)
;;EZsource   = TEXT_MEM2    ;;word
;;EZdest     = EZsource   + 2 ;;word
;;EZdestdone = EZdest     + 2 ;;word
;;EZpasses   = EZdestdone + 2 ;;byte
;;EZlookup   = EZpasses   + 1 ;;word

;;;;;;the single pass decoder is needed
#include "ezcmpsp.asm"


;;;;EZCMPDecodeMPass(hl->EZCMPdataPASSES) ;;Multiple Passes of decoding
;;;HL must be pointing to the actual address, ie PROGRAM_ADDR must
;;;already have been added if needed.
;;;As this function is written, it only works with data of 1k or smaller.
;;;On completion both GRAPH_MEM and VIDEO_MEM will contain the output image.
EZCMPDecodeMPass:
   ld   a,(hl)   ;;load first byte which is count of passes (1 or greater)
   inc  hl
   ld   b,a
EZCMPloopmp:
   push bc
   ld   de,VIDEO_MEM
	CALL_(EZCMPDecodeOPass)
   ld   hl,VIDEO_MEM
   ld   de,GRAPH_MEM
   ld   bc,1024
   ldir
   ld   hl,GRAPH_MEM
   pop  bc
   djnz EZCMPloopmp
   ret
;;;;;;;end EZCMP decode multi pass


;;;;;;;;;;;;;;;;;;;;end of this file
